<?php

/***************************************************************************************
 *											*
 *   	Copyright 2006 by Davide Simoncelli                                      	*
 *   	Email: netcelli_gentoo at users dot sourceforge dot net                      	*
 *                                                                         		*
 *   	This program is free software; you can redistribute it and/or			*
 *	modify it under the terms of the GNU General Public License			*
 *	as published by the Free Software Foundation; either version 2			*
 *	of the License, or (at your option) any later version.				*
 *											*
 *	This program is distributed in the hope that it will be useful,			*
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of			*
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the			*
 *	GNU General Public License for more details.					*
 *											*
 *	You should have received a copy of the GNU General Public License		*
 *	along with this program; if not, write to the Free Software			*
 *	Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.	*	
 *											*
 ****************************************************************************************/

/**
 *	@name User
 * 	@package VHCP
*/


class User
{

	private $user_nick;
	private $user_class;
	
	public function __construct()
	{
		$this->user_nick = 'Anonymous';
		$this->user_class = 0;
	}
	
	/*public function __construct($_nick)
	{
		$this->user_nick = $nick;
		$this->user_class = $this->getClass();
	}*/
	
	/**
     * Set the $user_nick for the Object User
     * @param string $_nick the new nick
     * @access public
     */
	
	public function setNick($_nick,$set=false)
	{
		if ($set) $this->updateUser('nick',$_nick);
		$this->user_nick = $_nick;
	}

	/**
     * Set the $user_class for the Object User
     * @param string $_class the new class
     * @access public
     */
	
	public function setClass($_class, $set=false)
	{
		if ($set) $this->updateUser('class',$_class);
		$this->user_class = $_class;
	}

	/**
     * Check if an user got privileges
     * @param string $class the user's class
     * @param bool $echo show an error message
     * @global $classes
     * @access public
     * @return bool
     */
	
	public function checkClass($class,$echo=true)
	{
		global $classes;
		if($this->user_class >=$class)
		{
			return true;
		}
		else
		{
			if($echo)
			{
				echo "<div align=\"center\"><br><br><div align=\"center\" style=\"font-family:verdana;font-size:11px;border:2px dashed #CC3333;padding:3px;margin:3px;background-color:F6F6F6;width:320px;\"><b><font color=\"#CC3300\">No access, class to low.</b></font><br> Your class: ".$classes[USER_CLASS]." (".USER_CLASS."), Required class: {$classes[$class]} ($class)<br /></div></div>\n";
			}
			return false;
		}
	}
	
	 /**
     * Check if the user is regged for login form
     * @param string $nick the nick to check
     * @param string $pass the password to log in
     * @access public
     * @return bool
     */
	
	public function checkUser($nick,$pass)
	{
		$query = mysql_query("SELECT `nick`,`login_pwd`, `login_cnt` FROM `reglist` WHERE `nick` = '$nick' AND `class` > '0' LIMIT 1") or $this->error(mysql_error());
		$q = mysql_query("SELECT `val` FROM `SetupList` WHERE `var` = 'default_password_encryption' AND `file` = 'config' LIMIT 1") or $this->error(mysql_error());
		if(mysql_num_rows($q)>0)
		{
			$r = mysql_fetch_assoc($q);
			if ($result = mysql_fetch_assoc($query))
			{
				// 1 means crypt
				if ($r['val'])
				{
					if($result['login_pwd'] === crypt($pass,$result['login_pwd']))
					{
						return true;
					}
					else
					{
						return false;
					}
				}
				// 0 means no crypt
				elseif (!$r['val'])
				{
					if($result['login_pwd'] === $pass)
					{
						return true;
					}
					else
					{
						return false;
					}
				}
				// 2 means md5
				elseif ($r['val'] == 2)
				{
					if($result['login_pwd'] === md5($pass))
					{
						return true;
					}
					else
					{
						return false;
					}
				}
			}
			else
			{
				return false;
			}
				
		}
		else
		{
			$result = mysql_fetch_assoc($query);
			if($result['login_pwd'] === crypt($pass,$result['login_pwd']))
				{
					return true;
				}
				else
				{
					return false;
				}
		
		}
	}
	
	/**
     * Get some users info
     * @param string $nick
     * @param string $fields
     * @access public
     * @return bool
     */
	
	public function getUserInfo($fields="*")
	{
		$query = MySQL::runQuery("SELECT $fields FROM `reglist` WHERE `nick` = '$this->user_nick' LIMIT 1",true);
		if(mysql_num_rows($query)>0)
		{
			$result = mysql_fetch_assoc($query);
			return $result;
		}
		else
		{
			return false;
		}
	}
	
	/**
     * Return the user's class
     * @access public
     * @return integer
     */
	
	public function getClass()
	{
		$user = $this->getUserInfo("`class`");
		return intval($user['class']);
		//return $this->user_class;
	}
	
	/**
     * Return the user's nick
     * @access public
     * @return integer
     */
	
	public function getNick()
	{
		return $this->user_nick;
	}
	
	/**
     * Update user info
     * @param string $nick
     * @param string $setting
     * @param string $value
     * @access public
     */
	
	public function updateUser($setting,$value)
	{
		MySQL::runQuery("UPDATE `reglist` SET `$setting` = '$value' WHERE `nick` = '{$this->user_nick}'");
	}
	
	/**
     * Check if the ip can see something
     * @access public
     */
		
	public function checkAccessByIp()
	{
		$ips = Verlidb::VHCP_config('access');
		if ($ips=='all') $access = array(VHCP_config::VHCP_config('access'));
		else
		{
			$i = 0;
			$ip = explode(",",$ips);
			foreach ($ip as $val)
			{
				++$i;
				$access[$i] = $val;
			}
		}
	}
}
?>